//Ban_Kai_Zangetsu.cs
datablock AudioProfile(Ban_Kai_ZangetsuDrawSound)
{
   filename    = "./Ban_Kai_ZangetsuDraw.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(Ban_Kai_ZangetsuHitSound)
{
   filename    = "./Ban_Kai_ZangetsuHit.wav";
   description = AudioClosest3d;
   preload = true;
};


//effects
datablock ParticleData(Ban_Kai_ZangetsuExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = -2.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   spinRandomMin = -100;
   spinRandomMax = -100;
   lifetimeMS           = 1900;
   lifetimeVarianceMS   = 1000;
   textureName          = "./Ban_Kai_Zangetsuchunk";
   colors[0]     = "0.7 0.2 0.2 0.9";
   colors[1]     = "0.9 0.2 0.2 0.9";
   sizes[0]      = 0.5;
   sizes[1]      = 0.25;
};

datablock ParticleEmitterData(Ban_Kai_ZangetsuExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Ban_Kai_ZangetsuExplosionParticle";

   uiName = "Ban_Kai_Zangetsu Hit";
};

datablock ExplosionData(Ban_Kai_ZangetsuExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   soundProfile = Ban_Kai_ZangetsuHitSound;

   particleEmitter = Ban_Kai_ZangetsuExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 0;
   lightStartColor = "2.0 0.2 0.6";
   lightEndColor = "0 0 0";
};


//projectile
AddDamageType("Ban_Kai_Zangetsu",   '<bitmap:add-ons/Weapon_Ban_Kai_Zangetsu/CI_Ban_Kai_Zangetsu> %1',    '%2 <bitmap:add-ons/Weapon_Ban_Kai_Zangetsu/CI_Ban_Kai_Zangetsu> %1',0.75,1);
datablock ProjectileData(Ban_Kai_ZangetsuProjectile)
{
   directDamage        = 50;
   directDamageType  = $DamageType::Ban_Kai_Zangetsu;
   radiusDamageType  = $DamageType::Ban_Kai_Zangetsu;
   explosion           = Ban_Kai_ZangetsuExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 100;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 1000;
   fadeDelay           = 70;
   bounceElasticity    = 2;
   bounceFriction      = 2;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 0.5;
   lightColor  = "0.5 0 0";

   uiName = "Ban_Kai_Zangetsu Slice";
};


//////////
// item //
//////////
datablock ItemData(Ban_Kai_ZangetsuItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Ban_Kai_Zangetsu.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Zangetsu (BK)";
	iconName = "./icon_Ban_Kai_Zangetsu";
	doColorShift = true;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = Ban_Kai_ZangetsuImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(Ban_Kai_ZangetsuImage)
{
   // Basic Item properties
   shapeFile = "./Ban_Kai_Zangetsu.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = Ban_Kai_ZangetsuItem;
   ammo = " ";
   projectile = Ban_Kai_ZangetsuProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = Ban_Kai_ZangetsuDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";


};

function Ban_Kai_ZangetsuImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}

function Ban_Kai_ZangetsuImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}